routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    $products = App\Models\Product::with('category')->get();
    return view('welcome', compact('products'));
});

Auth::routes();

Route::group(['middleware' => ['auth']], function() {
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
    Route::resource('products', App\Http\Controllers\ProductController::class);
    Route::resource('categories', App\Http\Controllers\CategoryController::class);
});

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Category extends Model
{
    use HasFactory;
    use SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'description',
    ];

    /**
     * Get the products for the blog post.
     */
    public function products()
    {
        return $this->hasMany(Product::class);
    }
}

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use App\Http\Requests\StoreCategoryRequest;
use App\Http\Requests\UpdateCategoryRequest;
use App\DataTables\CategoriesDataTable;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(CategoriesDataTable $dataTable)
    {
        return $dataTable->render('categories.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $category = new Category();
        return view('categories.create', compact('category'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \App\Http\Requests\StoreCategoryRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreCategoryRequest $request)
    {
        try {
            $input = $request->validated();
            Category::create($input);

            alert()->success('Success', 'Category created successfully');
            return redirect()->route('categories.index');

        } catch (\Throwable $e) {
            report($e);
            alert()->error('Error', 'Failed to create Category');
            return redirect()->back()->withInput();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function show(Category $category)
    {
        return view('categories.show', compact('category'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function edit(Category $category)
    {
        return view('categories.edit', compact('category'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \App\Http\Requests\UpdateCategoryRequest  $request
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateCategoryRequest $request, Category $category)
    {
        try {
            $input = $request->validated();
            $category->update($input);

            alert()->success('Success', 'Category updated successfully');
            return redirect()->route('categories.index');

        } catch (\Throwable $e) {
            report($e);
            alert()->error('Error', 'Failed to update Category');
            return redirect()->back()->withInput();
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function destroy(Category $category)
    {
        try {
            $category->delete();

            alert()->success('Success', 'Category deleted successfully');
            return redirect()->route('categories.index');

        } catch (\Throwable $e) {
            report($e);
            alert()->error('Error', 'Failed to delete Category');
            return redirect()->back()->withInput();
        }
    }
}

resources/views/categories/_form.blade.php
<div class="mb-3">
    <label for="name" class="form-label">Name</label>
    <input type="text" class="form-control" id="name" placeholder="" name="name" value="{{ old('name', $category->name) }}">
    <div class="invalid-feedback">
      Please enter a message in the textarea.
    </div>
    @if ($errors->has('name'))
    <small class="text-danger">{{ $errors->first('name') }}</small>
    @endif
</div>
<div class="mb-3">
    <label for="description" class="form-label">Description</label>
    <textarea class="form-control" id="description" rows="3" name="description">{{ old('description', $category->description) }}</textarea>
    @if ($errors->has('description'))
    <small class="text-danger">{{ $errors->first('description') }}</small>
    @endif
</div>
<div class="pt-3 float-end">
    <a href="{{ route('categories.index') }}"><button type="button" class="btn btn-light">Kembali</button></a>
    @isset($show)
    {{-- this button only on show --}}
    <a href="{{ route('categories.edit', $category) }}"><button type="button" class="btn btn-primary">Edit</button></a>
    @else
    <button type="submit" class="btn btn-primary">Submit</button>
    @endif
</div>

resources/views/categories/action.blade.php
<a href="{{ route('categories.show', $id) }}" title="Show detail"><i class="bi bi-eye"></i></a>
<a href="{{ route('categories.edit', $id) }}" title="Edit"><i class="bi bi-pencil-square"></i></a>
<a href="#" data-href="{{ route('categories.destroy', $id) }}" title="Delete" class="btn-delete"><i class="bi bi-trash"></i></a>

resources/views/categories/create.blade.php
@extends('layouts.app')

@section('css')
    {{-- load css from layouts parent here --}}
    @parent

    {{-- put custom css per page here --}}
    {{-- ckeditor for input description --}}
    <style type="text/css">
        .ck-editor__editable_inline {
            min-height: 150px;
        }
    </style>
@endsection

@section('js')
    {{-- load js from layouts parent here --}}
    @parent

    {{-- put custom js per page here --}}
    {{-- ckeditor for input description --}}
    <script src="https://cdn.ckeditor.com/ckeditor5/31.1.0/classic/ckeditor.js"></script>
    <script>
        ClassicEditor
            .create( document.querySelector( '#description' ) )
            .catch( error => {
                console.error( error );
            } );
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-10">
            <div class="card">
                <div class="card-header">{{ __('Create Category') }}</div>

                <div class="card-body">
                    <form class="form" id="form-category" action="{{ route('categories.store') }}" method="POST">
                        @csrf
                        @include('categories._form')
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

@endsection

resources/views/categories/edit.blade.php
@extends('layouts.app')

@section('css')
    {{-- load css from layouts parent here --}}
    @parent

    {{-- put custom css per page here --}}
    {{-- ckeditor for input description --}}
    <style type="text/css">
        .ck-editor__editable_inline {
            min-height: 150px;
        }
    </style>
@endsection

@section('js')
    {{-- load js from layouts parent here --}}
    @parent

    {{-- put custom js per page here --}}
    {{-- ckeditor for input description --}}
    <script src="https://cdn.ckeditor.com/ckeditor5/31.1.0/classic/ckeditor.js"></script>
    <script>
        ClassicEditor
            .create( document.querySelector( '#description' ) )
            .catch( error => {
                console.error( error );
            } );
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-10">
            <div class="card">
                <div class="card-header">{{ __('Edit Category') }}</div>

                <div class="card-body">
                    <form class="form" id="form-category" action="{{ route('categories.update', $category) }}" method="POST">
                        @csrf
                        @method('PUT')
                        @include('categories._form')
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

@endsection

resources/views/categories/index.blade.php
@extends('layouts.app')

@section('css')
    {{-- load css from layouts parent here --}}
    @parent
    
    {{-- put custom css per page here --}}
    <link rel="stylesheet" href="https://cdn.datatables.net/1.11.3/css/dataTables.bootstrap5.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/buttons/1.0.3/css/buttons.dataTables.min.css">

    <style type="text/css">
        /*description max line to show*/
        .text-description {
            min-width: 300px;
        }
    </style>
@endsection

@section('js')
    {{-- load js from layouts parent here --}}
    @parent

    {{-- put custom js per page here --}}
    <script src="https://cdn.datatables.net/1.11.3/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.11.3/js/dataTables.bootstrap5.min.js"></script>
    <script src="https://cdn.datatables.net/buttons/1.0.3/js/dataTables.buttons.min.js"></script>
    <script src="{{ asset('vendor/datatables/buttons.server-side.js') }}"></script>

    {{-- render script datatable from yajra --}}
    {{$dataTable->scripts()}}

    {{-- delete action --}}
    <script type="text/javascript">
        $(document.body).on("click", ".btn-delete",function() {
            var url = $(this).data('href');

            Swal.fire({
                title: 'Delete category',
                text: 'Are you sure to delete this category ?',
                icon: 'warning',
                showCancelButton: true,
                confirmButtonText: 'Delete',
            }).then((result) => {
                if (result.isConfirmed) {
                    $('#form-group-delete').attr('action', url);
                    $('#form-group-delete').submit();
                }
            });
        });
    </script>

    {{-- remove db-button class --}}
    <script type="text/javascript">
        $(document).ready(function() {
            $('.dt-button').removeClass('dt-button');
        });
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header">{{ __('List Categories') }}</div>

                <div class="card-body" style="font-size: 0.85rem;">
                    {{-- render datatable from yajra --}}
                    {{$dataTable->table(['class' => 'table table-bordered', 'width' => '100%'])}}
                </div>
            </div>
        </div>
    </div>
</div>

{{-- form delete, populated from jquery event click button delete --}}
<form id="form-group-delete" action="" method="post" class="d-none">
    @csrf
    @method('DELETE')
</form>
@endsection

resources/views/categories/show.blade.php
@extends('layouts.app')

@section('css')
    {{-- load css from layouts parent here --}}
    @parent

    {{-- put custom css per page here --}}
@endsection

@section('js')
    {{-- load js from layouts parent here --}}
    @parent

    {{-- put custom js per page here --}}
    <script>
        $(document).ready(function() {
            // disable form input
            $('#form-category input').prop('disabled', true);
            $('#form-category select').prop('disabled', true);
            $('#form-category textarea').prop('disabled', true);
        });
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-10">
            <div class="card">
                <div class="card-header">{{ __('Detail Category') }}</div>

                <div class="card-body">
                    <form class="form" id="form-category" action="" method="POST">
                        @include('categories._form', ['show'=>true])
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

@endsection